#!/usr/bin/perl -w
#
# $Id: InfoBox.pm,v 1.11 2003/06/29 05:01:48 solovam Exp $
#
# InfoBox class
#
package InfoBox;

use Gtk;
use Misc;
use strict;

my @labels = ('Networks', 'Packets', 'Crypt', 'Weak', 'Noise', 'Dropped', 'Rate', 'Signal');

#
# Constructor
#
sub new
{
	my $type = shift;
	my $self = {};
	bless $self, $type;

	my $frame = new Gtk::Frame(undef);
	$self->{'frame'} = $frame;
	my $vbox = new Gtk::VBox($false, 5);
	$frame->add($vbox);

	for my $l (@labels)
	{
		my $hbox = new Gtk::HBox($false, 1);

		my $nlabel = new Gtk::Label($l . ': ');
		$nlabel->set_justify('left');
		$hbox->pack_start($nlabel, $false, $false, 5);

		my $vlabel = new Gtk::Label('');
		$vlabel->set_justify('right');
		$hbox->pack_end($vlabel, $false, $false, 5);

		$vbox->pack_start($hbox, $false, $false, 3);
	
		$self->{'label'}{$l} = $vlabel;
	}
	$frame->show_all();

	return $self;
}

#
# Remove all stored data
#
sub flush
{
	my $self = shift;
	for my $l (@labels)
	{
		$self->{'label'}{$l}->set_text('');
	}
}

#
# Handle an update from an observable
#
sub update
{
	my $self = shift;
	my $object = shift;
	my $data = shift;

	if($object->isa('Connection'))
	{
		if($data->{'updateType'} eq 'info')
		{
			for my $l (@labels)
			{
				$self->{'label'}{$l}->set_text($data->{'update'}{lc($l)});
			}
		}
	}
}

#
# Get Gtk widget
#
sub getWidget
{
	my $self = shift;
	return($self->{'frame'});
}

1;
