#!/usr/bin/perl -w
#
# $Id: Observable.pm,v 1.2 2003/06/29 02:37:00 solovam Exp $
#

#
# Observable class
#
package Observable;

use strict;
use Exporter();

our(@ISA, @EXPORT);

@ISA = qw(Exporter);
@EXPORT = qw(notifyObservers addObserver removeObserver);

#
# Constructor
#
sub new
{
	my $type = shift;
	my $self = {};
	bless $self, $type;
	return $self;
}

#
# Notify observers
#
sub notifyObservers
{
	my $self = shift;
	my $data = shift;

	for my $observer (keys %{$self->{'observers'}})
	{
		$self->{'observers'}{$observer}->update($self, $data);
	}
}

#
# Register an observer
#
sub addObserver
{
	my $self = shift;
	my $observer = shift;
	$self->{'observers'}{$observer} = $observer;
}

#
# Remove observer
#
sub removeObserver
{
	my $self = shift;
	my $observer = shift;
	if(defined $self->{'observers'}{$observer})
	{
		delete $self->{'observers'}{$observer};
	}
}

1;
