#!/usr/bin/perl -w
#
# $Id: StatusBar.pm,v 1.15 2003/06/29 05:02:43 solovam Exp $
#
# StatusBar class
#
package StatusBar;

use strict;
use Gtk;
use Misc;

#
# Constructor
#
sub new
{
	my $type = shift;
	my $self = {};
	bless $self, $type;

	$self->{'statusBar'} = new Gtk::Statusbar();
	$self->{'sbContext'} = $self->{'statusBar'}->get_context_id('status line');
	$self->{'statusBar'}->show();
	$self->{'depth'} = 0;

	return $self;
}

#
# Handle an update from an observable
#
sub update
{
	my $self = shift;
	my $object = shift;
	my $data = shift;

	if($object->isa('Connection'))
	{
		if($data->{'updateType'} eq 'status')
		{
			$self->{'statusBar'}->push($self->{'sbContext'}, $data->{'update'}{'status'});
			$self->{'depth'}++;
		}
	}
}

#
# Flush all accumulated data
#
sub flush
{
	my $self = shift;
	while($self->{'depth'} > 0)
	{
		$self->{'statusBar'}->pop($self->{'sbContext'});
		$self->{'depth'}--;
	}
}

#
# Get widget
#
sub getWidget
{
	my $self = shift;
	return($self->{'statusBar'});
}

1;
